package com.zksy.web.controller.basicData;

import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmCreditManagement;
import com.zksy.system.basicData.service.CrmCreditManagementService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 信用管理部门或岗位Controller
 *
 * @author sy
 * @date 2024-06-03
 */
@RestController
@RequestMapping("/crmCreditManagement")
@Api(tags = "信用管理部门或岗位", description = "信用管理部门或岗位desc")
public class CrmCreditManagementController extends BaseController{

    @Autowired
    private CrmCreditManagementService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "信用管理部门或岗位搜索getById")
    public CrmCreditManagement getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "信用管理部门或岗位分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "信用管理部门或岗位查询所有")
    public List<CrmCreditManagement> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增信用管理部门或岗位
     */
    @PostMapping("/save")
    @ApiOperation(value = "信用管理部门或岗位新增")
    @Log(title = "新增信用管理部门或岗位", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmCreditManagement crmCreditManagement) {
        return service.save(crmCreditManagement);
    }

    /**
     * 修改信用管理部门或岗位
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "信用管理部门或岗位修改")
    @Log(title = "修改信用管理部门或岗位", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmCreditManagement crmCreditManagement) {
        return service.updateById(crmCreditManagement);
    }

    /**
     * 导入信用管理部门或岗位
     */
    @ApiOperation("信用管理部门或岗位导入")
    @Log(title = "信用管理部门或岗位", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmCreditManagement> crmCreditManagementAll = service.list();
            List<CrmCreditManagement> list = ExcelUtils.readMultipartFile(file, CrmCreditManagement.class,CrmCreditManagement.class.getDeclaredFields().length - 2);
            if(crmCreditManagementAll != null && crmCreditManagementAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("信用管理部门或岗位导出")
    @Log(title = "信用管理部门或岗位", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmCreditManagement> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"信用管理部门或岗位",wrapperList,CrmCreditManagement.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "信用管理部门或岗位", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除信用管理部门或岗位", notes = "删除信用管理部门或岗位")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"信用管理部门或岗位模板");
    }
}

